stages:
- build
- lint
- images
- publish

variables:
  GO_VERSION: "1.15.6"
  GO_IMAGE: golang:$GO_VERSION
  GOPATH: $CI_PROJECT_DIR/.go
  EXPORTER_IMAGE: $CI_REGISTRY_IMAGE/exporter:$CI_COMMIT_SHA
  HELM_IMAGE: registry.gitlab.com/edgetic/ci/helm:v3.4.2
  IPMI_SENSORS_CHART: deploy/charts/ipmi-sensors
  CI_IMAGE_TAG: $CI_COMMIT_SHA

build:
  image: $GO_IMAGE
  stage: build
  script:
    - apt update && apt install -y libipmimonitoring-dev
    - make build
    - make lint
    - make test
  artifacts:
    paths:
    - deploy/
  cache:
    paths:
    - $GOPATH/pkg/mod/
    key: ${CI_COMMIT_REF_SLUG}-gomodules

helm lint:
  image: $HELM_IMAGE
  stage: lint
  script:
    - yq e -i ".image.tag = \"$CI_IMAGE_TAG\"" $IPMI_SENSORS_CHART/values.yaml
    - helm lint $IPMI_SENSORS_CHART
    - helm dep update $IPMI_SENSORS_CHART
  variables:
    GIT_STRATEGY: none
  artifacts:
    paths:
    - deploy/

.build_image:
  image:
    name: registry.gitlab.com/edgetic/ci/makisu:v0.4.0
  stage: images
  variables:
    BUILD_ARG: --build-arg GO_VERSION=$GO_VERSION

build exporter image:
  extends: .build_image
  script:
  - build -f build/exporter/Dockerfile $BUILD_ARG -t $EXPORTER_IMAGE .

helm publish:
  image: $HELM_IMAGE
  stage: publish
  script:
    - echo $GOOGLE_APPLICATION_CREDENTIALS > helm-bucket.json
    - export GOOGLE_APPLICATION_CREDENTIALS=helm-bucket.json
    - helm repo add edgetic-stable gs://edgetic-helm/stable
    - helm package --app-version $CI_COMMIT_TAG --version $CI_COMMIT_TAG $IPMI_SENSORS_CHART
    - helm gcs push ipmi-sensors-$CI_COMMIT_TAG.tgz edgetic-stable
  variables:
    GIT_STRATEGY: none
  only:
    - tags
